cscript "betafit" adofiles betafit
use bench/governing.dta, clear
gen lnpop = ln(popdens)
gen lnhous = ln(houseval)
gen baseline = 1


betafit governing

assert `"`e(predict)'"'    == `"betafit_p"'
assert `"`e(depvar)'"'     == `"governing"'
assert `"`e(cmd)'"'        == `"betafit"'
assert `"`e(chi2type)'"'   == `"Wald"'
assert `"`e(title)'"'      == `"ML fit of beta (alpha, beta)"'
assert `"`e(user)'"'       == `"betafit_lf"'
assert `"`e(crittype)'"'   == `"log likelihood"'
assert `"`e(technique)'"'  == `"nr"'

assert         e(rc)             == 0
assert reldif( e(ll)              , 719.4782267706879 ) <  1E-6
assert         e(rank)           == 2
assert         e(k)              == 2
assert         e(k_eq)           == 2
assert         e(k_dv)           == 0
assert         e(ic)             == 3
assert         e(N)              == 394
assert         e(df_m)           == 0
assert         e(length_b_beta)  == 1
assert         e(length_b_alpha) == 1
assert reldif( e(alpha)           , 4.809587089363821 ) <  1E-4
assert reldif( e(beta)            , 45.40354761950029 ) <  1E-4

tempname T_b 
mat `T_b' = J(1,2,0)
mat `T_b'[1,1] =  4.809587089363821
mat `T_b'[1,2] =  45.40354761950029
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-6
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"alpha:_cons beta:_cons"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(2,2,0)
mat `T_V'[1,1] =   .109907303870095
mat `T_V'[1,2] =  1.026203145185384
mat `T_V'[2,1] =  1.026203145185384
mat `T_V'[2,2] =    10.759784082639
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-3
_assert_streq `"`: rowfullnames `C_V''"' `"alpha:_cons beta:_cons"'
_assert_streq `"`: colfullnames `C_V''"' `"alpha:_cons beta:_cons"'
mat drop `C_V' `T_V'

tempname T_b_alpha 
mat `T_b_alpha'=  4.809587089363821
tempname C_b_alpha
matrix `C_b_alpha' = e(b_alpha)
assert mreldif( `C_b_alpha' , `T_b_alpha' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_alpha''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_alpha''"' `"alpha:_cons"'
mat drop `C_b_alpha' `T_b_alpha'

tempname T_b_beta 
mat `T_b_beta'=  45.40354761950029
tempname C_b_beta
matrix `C_b_beta' = e(b_beta)
assert mreldif( `C_b_beta' , `T_b_beta' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_beta''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_beta''"' `"beta:_cons"'
mat drop `C_b_beta' `T_b_beta'

betafit governing, alt

assert `"`e(predict)'"'    == `"betafit_p"'
assert `"`e(depvar)'"'     == `"governing"'
assert `"`e(cmd)'"'        == `"betafit"'
assert `"`e(chi2type)'"'   == `"Wald"'
assert `"`e(title)'"'      == `"ML fit of beta (mu, phi)"'
assert `"`e(user)'"'       == `"betareg_lf"'
assert `"`e(crittype)'"'   == `"log likelihood"'
assert `"`e(technique)'"'  == `"nr"'

assert         e(rc)           == 0
assert reldif( e(ll)            , 719.4782267706885 ) <  1E-6
assert         e(rank)         == 2
assert         e(k)            == 2
assert         e(k_eq)         == 2
assert         e(k_dv)         == 0
assert         e(ic)           == 3
assert         e(N)            == 394
assert         e(df_m)         == 0
assert         e(length_b_mu)  == 1
assert         e(length_b_phi) == 1
assert         e(k_aux)        == 1
assert reldif( e(mu)            , -2.244979017064618) <  1E-4
assert reldif( e(ln_phi)        , 3.91627625831044  ) <  1E-4

tempname T_b 
mat `T_b' = J(1,2,0)
mat `T_b'[1,1] = -2.244979017064618
mat `T_b'[1,2] =   3.91627625831044
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-6
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"mu:_cons ln_phi:_cons"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(2,2,0)
mat `T_V'[1,1] =  .0005720690796839
mat `T_V'[1,2] =  -.000465320096361
mat `T_V'[2,1] =  -.000465320096361
mat `T_V'[2,2] =  .0051250859119183
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-3
_assert_streq `"`: rowfullnames `C_V''"' `"mu:_cons ln_phi:_cons"'
_assert_streq `"`: colfullnames `C_V''"' `"mu:_cons ln_phi:_cons"'
mat drop `C_V' `T_V'

tempname T_b_phi 
mat `T_b_phi'=   3.91627625831044
tempname C_b_phi
matrix `C_b_phi' = e(b_phi)
assert mreldif( `C_b_phi' , `T_b_phi' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_phi''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_phi''"' `"ln_phi:_cons"'
mat drop `C_b_phi' `T_b_phi'

tempname T_b_mu 
mat `T_b_mu'= -2.244979017064618
tempname C_b_mu
matrix `C_b_mu' = e(b_mu)
assert mreldif( `C_b_mu' , `T_b_mu' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_mu''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_mu''"' `"mu:_cons"'
mat drop `C_b_mu' `T_b_mu'

betafit governing , mu(minorityleft noleft lnhous lnpop) phi(lnpop lnhous minorityleft noleft)
assert `"`e(predict)'"'    == `"betafit_p"'
assert `"`e(depvar)'"'     == `"governing"'
assert `"`e(cmd)'"'        == `"betafit"'
assert `"`e(chi2type)'"'   == `"Wald"'
assert `"`e(title)'"'      == `"ML fit of beta (mu, phi)"'
assert `"`e(user)'"'       == `"betareg_lf"'
assert `"`e(crittype)'"'   == `"log likelihood"'
assert `"`e(technique)'"'  == `"nr"'

assert         e(rc)           == 0
assert reldif( e(ll)            , 788.7775331980427 ) <  1E-6
assert         e(rank)         == 10
assert         e(k)            == 10
assert         e(k_eq)         == 2
assert         e(k_dv)         == 0
assert         e(ic)           == 4
assert         e(N)            == 394
assert         e(df_m)         == 4
assert reldif( e(chi2)          , 125.2137798833109 ) <  1E-4
assert reldif( e(p)             , 4.10844360997e-26 ) <  1E-4
assert         e(length_b_mu)  == 5
assert         e(length_b_phi) == 5

tempname T_b 
mat `T_b' = J(1,10,0)
mat `T_b'[1,1] = -.1448706435994521
mat `T_b'[1,2] =  .0956251613049351
mat `T_b'[1,3] =  .5668401835267978
mat `T_b'[1,4] = -.0992651268403357
mat `T_b'[1,5] = -2.531938957374284
mat `T_b'[1,6] = -.1086676564141307
mat `T_b'[1,7] =  -.971410352680537
mat `T_b'[1,8] =  .7816604434954078
mat `T_b'[1,9] =  .4479463372375471
mat `T_b'[1,10] =  4.032038384797002
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-6
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"mu:minorityleft mu:noleft mu:lnhous mu:lnpop mu:_cons ln_phi:lnpop ln_phi:lnhous ln_phi:minorityleft ln_phi:noleft ln_phi:_cons"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(10,10,0)
mat `T_V'[1,1] =  .0047115444827234
mat `T_V'[1,2] =  .0038456470503916
mat `T_V'[1,3] =  -.000165511132861
mat `T_V'[1,4] = -.0000527877633006
mat `T_V'[1,5] = -.0038471344836092
mat `T_V'[1,6] =  .0008572870956084
mat `T_V'[1,7] = -.0046114551940366
mat `T_V'[1,8] = -.0035879964843897
mat `T_V'[1,9] = -.0019439239247273
mat `T_V'[1,10] =  .0049683027568475
mat `T_V'[2,1] =  .0038456470503916
mat `T_V'[2,2] =  .0049450094116998
mat `T_V'[2,3] = -.0008828801627547
mat `T_V'[2,4] =  .0001435495850957
mat `T_V'[2,5] = -.0034083961500332
mat `T_V'[2,6] =  .0002822962850994
mat `T_V'[2,7] = -.0039302302891146
mat `T_V'[2,8] = -.0022971121754358
mat `T_V'[2,9] = -.0026413649770983
mat `T_V'[2,10] =  .0039286752961278
mat `T_V'[3,1] =  -.000165511132861
mat `T_V'[3,2] = -.0008828801627547
mat `T_V'[3,3] =  .0066639571048368
mat `T_V'[3,4] =  -.000229149709808
mat `T_V'[3,5] = -.0020652603551956
mat `T_V'[3,6] =  .0003794736115372
mat `T_V'[3,7] = -.0039767067838628
mat `T_V'[3,8] = -.0032593851589378
mat `T_V'[3,9] = -.0023598318641717
mat `T_V'[3,10] =  .0039895017032689
mat `T_V'[4,1] = -.0000527877633006
mat `T_V'[4,2] =  .0001435495850957
mat `T_V'[4,3] =  -.000229149709808
mat `T_V'[4,4] =  .0004226308138298
mat `T_V'[4,5] =  .0004744411889101
mat `T_V'[4,6] = -.0003491978287733
mat `T_V'[4,7] =  .0004478902814556
mat `T_V'[4,8] =  .0007572306476341
mat `T_V'[4,9] =     .0001159467848
mat `T_V'[4,10] = -.0008918560796625
mat `T_V'[5,1] = -.0038471344836092
mat `T_V'[5,2] = -.0034083961500332
mat `T_V'[5,3] = -.0020652603551956
mat `T_V'[5,4] =  .0004744411889101
mat `T_V'[5,5] =  .0048216173714563
mat `T_V'[5,6] = -.0010241203567246
mat `T_V'[5,7] =  .0056721286763876
mat `T_V'[5,8] =  .0045471713001653
mat `T_V'[5,9] =  .0029301364127616
mat `T_V'[5,10] = -.0066018230961826
mat `T_V'[6,1] =  .0008572870956084
mat `T_V'[6,2] =  .0002822962850994
mat `T_V'[6,3] =  .0003794736115372
mat `T_V'[6,4] = -.0003491978287733
mat `T_V'[6,5] = -.0010241203567246
mat `T_V'[6,6] =  .0053264533605181
mat `T_V'[6,7] = -.0010442613995439
mat `T_V'[6,8] = -.0008433618338886
mat `T_V'[6,9] =  .0021391182482637
mat `T_V'[6,10] =  .0042986490457861
mat `T_V'[7,1] = -.0046114551940366
mat `T_V'[7,2] = -.0039302302891146
mat `T_V'[7,3] = -.0039767067838628
mat `T_V'[7,4] =  .0004478902814556
mat `T_V'[7,5] =  .0056721286763876
mat `T_V'[7,6] = -.0010442613995439
mat `T_V'[7,7] =  .0852234170084301
mat `T_V'[7,8] =  .0023774778100833
mat `T_V'[7,9] = -.0082974354149371
mat `T_V'[7,10] = -.0304145637559682
mat `T_V'[8,1] = -.0035879964843897
mat `T_V'[8,2] = -.0022971121754358
mat `T_V'[8,3] = -.0032593851589378
mat `T_V'[8,4] =  .0007572306476341
mat `T_V'[8,5] =  .0045471713001653
mat `T_V'[8,6] = -.0008433618338886
mat `T_V'[8,7] =  .0023774778100833
mat `T_V'[8,8] =  .0427790652295497
mat `T_V'[8,9] =   .029577234509913
mat `T_V'[8,10] = -.0316189663085657
mat `T_V'[9,1] = -.0019439239247273
mat `T_V'[9,2] = -.0026413649770983
mat `T_V'[9,3] = -.0023598318641717
mat `T_V'[9,4] =     .0001159467848
mat `T_V'[9,5] =  .0029301364127616
mat `T_V'[9,6] =  .0021391182482637
mat `T_V'[9,7] = -.0082974354149371
mat `T_V'[9,8] =   .029577234509913
mat `T_V'[9,9] =  .0445581121422092
mat `T_V'[9,10] =   -.02520924918437
mat `T_V'[10,1] =  .0049683027568475
mat `T_V'[10,2] =  .0039286752961278
mat `T_V'[10,3] =  .0039895017032689
mat `T_V'[10,4] = -.0008918560796625
mat `T_V'[10,5] = -.0066018230961826
mat `T_V'[10,6] =  .0042986490457861
mat `T_V'[10,7] = -.0304145637559682
mat `T_V'[10,8] = -.0316189663085657
mat `T_V'[10,9] =   -.02520924918437
mat `T_V'[10,10] =  .0434454336766485
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-3
_assert_streq `"`: rowfullnames `C_V''"' `"mu:minorityleft mu:noleft mu:lnhous mu:lnpop mu:_cons ln_phi:lnpop ln_phi:lnhous ln_phi:minorityleft ln_phi:noleft ln_phi:_cons"'
_assert_streq `"`: colfullnames `C_V''"' `"mu:minorityleft mu:noleft mu:lnhous mu:lnpop mu:_cons ln_phi:lnpop ln_phi:lnhous ln_phi:minorityleft ln_phi:noleft ln_phi:_cons"'
mat drop `C_V' `T_V'

tempname T_b_phi 
mat `T_b_phi' = J(1,5,0)
mat `T_b_phi'[1,1] = -.1086676564141307
mat `T_b_phi'[1,2] =  -.971410352680537
mat `T_b_phi'[1,3] =  .7816604434954078
mat `T_b_phi'[1,4] =  .4479463372375471
mat `T_b_phi'[1,5] =  4.032038384797002
tempname C_b_phi
matrix `C_b_phi' = e(b_phi)
assert mreldif( `C_b_phi' , `T_b_phi' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_phi''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_phi''"' `"ln_phi:lnpop ln_phi:lnhous ln_phi:minorityleft ln_phi:noleft ln_phi:_cons"'
mat drop `C_b_phi' `T_b_phi'

tempname T_b_mu 
mat `T_b_mu' = J(1,5,0)
mat `T_b_mu'[1,1] = -.1448706435994521
mat `T_b_mu'[1,2] =  .0956251613049351
mat `T_b_mu'[1,3] =  .5668401835267978
mat `T_b_mu'[1,4] = -.0992651268403357
mat `T_b_mu'[1,5] = -2.531938957374284
tempname C_b_mu
matrix `C_b_mu' = e(b_mu)
assert mreldif( `C_b_mu' , `T_b_mu' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_mu''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_mu''"' `"mu:minorityleft mu:noleft mu:lnhous mu:lnpop mu:_cons"'
mat drop `C_b_mu' `T_b_mu'

betafit governing , mu(minorityleft noleft lnhous lnpop baseline, nocons) phi(lnpop lnhous minorityleft noleft baseline, nocons) rpr
assert `"`e(cmd)'"'        == `"betafit"'
assert `"`e(predict)'"'    == `"betafit_p"'
assert `"`e(depvar)'"'     == `"governing"'
assert `"`e(chi2type)'"'   == `"Wald"'
assert `"`e(title)'"'      == `"ML fit of beta (mu, phi)"'
assert `"`e(user)'"'       == `"betareg_lf"'
assert `"`e(crittype)'"'   == `"log likelihood"'
assert `"`e(technique)'"'  == `"nr"'

assert         e(rc)           == 0
assert reldif( e(ll)            , 788.7775331980427 ) <  1E-6
assert         e(rank)         == 10
assert         e(k)            == 10
assert         e(k_eq)         == 2
assert         e(k_dv)         == 0
assert         e(ic)           == 4
assert         e(N)            == 394
assert         e(df_m)         == 5
assert reldif( e(chi2)          , 13321.00339702102 ) <  1E-4
assert         e(p)            == 0
assert         e(k_eform)      == 1
assert         e(length_b_mu)  == 6
assert         e(length_b_phi) == 6

tempname T_b 
mat `T_b' = J(1,10,0)
mat `T_b'[1,1] = -.1448706435994521
mat `T_b'[1,2] =  .0956251613049351
mat `T_b'[1,3] =  .5668401835267978
mat `T_b'[1,4] = -.0992651268403357
mat `T_b'[1,5] = -2.531938957374284
mat `T_b'[1,6] = -.1086676564141307
mat `T_b'[1,7] =  -.971410352680537
mat `T_b'[1,8] =  .7816604434954078
mat `T_b'[1,9] =  .4479463372375471
mat `T_b'[1,10] =  4.032038384797002
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-6
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"mu:minorityleft mu:noleft mu:lnhous mu:lnpop mu:baseline ln_phi:lnpop ln_phi:lnhous ln_phi:minorityleft ln_phi:noleft ln_phi:baseline"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(10,10,0)
mat `T_V'[1,1] =  .0047115444827234
mat `T_V'[1,2] =  .0038456470503916
mat `T_V'[1,3] =  -.000165511132861
mat `T_V'[1,4] = -.0000527877633006
mat `T_V'[1,5] = -.0038471344836092
mat `T_V'[1,6] =  .0008572870956084
mat `T_V'[1,7] = -.0046114551940366
mat `T_V'[1,8] = -.0035879964843897
mat `T_V'[1,9] = -.0019439239247273
mat `T_V'[1,10] =  .0049683027568475
mat `T_V'[2,1] =  .0038456470503916
mat `T_V'[2,2] =  .0049450094116998
mat `T_V'[2,3] = -.0008828801627547
mat `T_V'[2,4] =  .0001435495850957
mat `T_V'[2,5] = -.0034083961500332
mat `T_V'[2,6] =  .0002822962850994
mat `T_V'[2,7] = -.0039302302891146
mat `T_V'[2,8] = -.0022971121754358
mat `T_V'[2,9] = -.0026413649770983
mat `T_V'[2,10] =  .0039286752961278
mat `T_V'[3,1] =  -.000165511132861
mat `T_V'[3,2] = -.0008828801627547
mat `T_V'[3,3] =  .0066639571048368
mat `T_V'[3,4] =  -.000229149709808
mat `T_V'[3,5] = -.0020652603551956
mat `T_V'[3,6] =  .0003794736115372
mat `T_V'[3,7] = -.0039767067838628
mat `T_V'[3,8] = -.0032593851589378
mat `T_V'[3,9] = -.0023598318641717
mat `T_V'[3,10] =  .0039895017032689
mat `T_V'[4,1] = -.0000527877633006
mat `T_V'[4,2] =  .0001435495850957
mat `T_V'[4,3] =  -.000229149709808
mat `T_V'[4,4] =  .0004226308138298
mat `T_V'[4,5] =  .0004744411889101
mat `T_V'[4,6] = -.0003491978287733
mat `T_V'[4,7] =  .0004478902814556
mat `T_V'[4,8] =  .0007572306476341
mat `T_V'[4,9] =     .0001159467848
mat `T_V'[4,10] = -.0008918560796625
mat `T_V'[5,1] = -.0038471344836092
mat `T_V'[5,2] = -.0034083961500332
mat `T_V'[5,3] = -.0020652603551956
mat `T_V'[5,4] =  .0004744411889101
mat `T_V'[5,5] =  .0048216173714563
mat `T_V'[5,6] = -.0010241203567246
mat `T_V'[5,7] =  .0056721286763876
mat `T_V'[5,8] =  .0045471713001653
mat `T_V'[5,9] =  .0029301364127616
mat `T_V'[5,10] = -.0066018230961826
mat `T_V'[6,1] =  .0008572870956084
mat `T_V'[6,2] =  .0002822962850994
mat `T_V'[6,3] =  .0003794736115372
mat `T_V'[6,4] = -.0003491978287733
mat `T_V'[6,5] = -.0010241203567246
mat `T_V'[6,6] =  .0053264533605181
mat `T_V'[6,7] = -.0010442613995439
mat `T_V'[6,8] = -.0008433618338886
mat `T_V'[6,9] =  .0021391182482637
mat `T_V'[6,10] =  .0042986490457861
mat `T_V'[7,1] = -.0046114551940366
mat `T_V'[7,2] = -.0039302302891146
mat `T_V'[7,3] = -.0039767067838628
mat `T_V'[7,4] =  .0004478902814556
mat `T_V'[7,5] =  .0056721286763876
mat `T_V'[7,6] = -.0010442613995439
mat `T_V'[7,7] =  .0852234170084301
mat `T_V'[7,8] =  .0023774778100833
mat `T_V'[7,9] = -.0082974354149371
mat `T_V'[7,10] = -.0304145637559682
mat `T_V'[8,1] = -.0035879964843897
mat `T_V'[8,2] = -.0022971121754358
mat `T_V'[8,3] = -.0032593851589378
mat `T_V'[8,4] =  .0007572306476341
mat `T_V'[8,5] =  .0045471713001653
mat `T_V'[8,6] = -.0008433618338886
mat `T_V'[8,7] =  .0023774778100833
mat `T_V'[8,8] =  .0427790652295497
mat `T_V'[8,9] =   .029577234509913
mat `T_V'[8,10] = -.0316189663085657
mat `T_V'[9,1] = -.0019439239247273
mat `T_V'[9,2] = -.0026413649770983
mat `T_V'[9,3] = -.0023598318641717
mat `T_V'[9,4] =     .0001159467848
mat `T_V'[9,5] =  .0029301364127616
mat `T_V'[9,6] =  .0021391182482637
mat `T_V'[9,7] = -.0082974354149371
mat `T_V'[9,8] =   .029577234509913
mat `T_V'[9,9] =  .0445581121422092
mat `T_V'[9,10] =   -.02520924918437
mat `T_V'[10,1] =  .0049683027568475
mat `T_V'[10,2] =  .0039286752961278
mat `T_V'[10,3] =  .0039895017032689
mat `T_V'[10,4] = -.0008918560796625
mat `T_V'[10,5] = -.0066018230961826
mat `T_V'[10,6] =  .0042986490457861
mat `T_V'[10,7] = -.0304145637559682
mat `T_V'[10,8] = -.0316189663085657
mat `T_V'[10,9] =   -.02520924918437
mat `T_V'[10,10] =  .0434454336766485
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-3
_assert_streq `"`: rowfullnames `C_V''"' `"mu:minorityleft mu:noleft mu:lnhous mu:lnpop mu:baseline ln_phi:lnpop ln_phi:lnhous ln_phi:minorityleft ln_phi:noleft ln_phi:baseline"'
_assert_streq `"`: colfullnames `C_V''"' `"mu:minorityleft mu:noleft mu:lnhous mu:lnpop mu:baseline ln_phi:lnpop ln_phi:lnhous ln_phi:minorityleft ln_phi:noleft ln_phi:baseline"'
mat drop `C_V' `T_V'

tempname T_b_phi 
mat `T_b_phi' = J(1,5,0)
mat `T_b_phi'[1,1] = -.1086676564141307
mat `T_b_phi'[1,2] =  -.971410352680537
mat `T_b_phi'[1,3] =  .7816604434954078
mat `T_b_phi'[1,4] =  .4479463372375471
mat `T_b_phi'[1,5] =  4.032038384797002
tempname C_b_phi
matrix `C_b_phi' = e(b_phi)
assert mreldif( `C_b_phi' , `T_b_phi' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_phi''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_phi''"' `"ln_phi:lnpop ln_phi:lnhous ln_phi:minorityleft ln_phi:noleft ln_phi:baseline"'
mat drop `C_b_phi' `T_b_phi'

tempname T_b_mu 
mat `T_b_mu' = J(1,5,0)
mat `T_b_mu'[1,1] = -.1448706435994521
mat `T_b_mu'[1,2] =  .0956251613049351
mat `T_b_mu'[1,3] =  .5668401835267978
mat `T_b_mu'[1,4] = -.0992651268403357
mat `T_b_mu'[1,5] = -2.531938957374284
tempname C_b_mu
matrix `C_b_mu' = e(b_mu)
assert mreldif( `C_b_mu' , `T_b_mu' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_mu''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_mu''"' `"mu:minorityleft mu:noleft mu:lnhous mu:lnpop mu:baseline"'
mat drop `C_b_mu' `T_b_mu'

tempname b v b2 v2
matrix `b' = e(b)
matrix `v' = e(V)

betafit governing , mu(minorityleft noleft lnhous lnpop) phi(lnpop lnhous minorityleft noleft) 
matrix `b2' = e(b)
matrix `v2' = e(V)
assert mreldif(`b', `b2') < 1E-4
assert mreldif(`v', `v2') < 1E-4


betafit governing , mu(minorityleft noleft lnhous lnpop baseline, nocons) phi(lnpop lnhous minorityleft noleft) 
matrix `b2' = e(b)
matrix `v2' = e(V)
assert mreldif(`b', `b2') < 1E-4
assert mreldif(`v', `v2') < 1E-4

betafit governing , mu(minorityleft noleft lnhous lnpop) phi(lnpop lnhous minorityleft noleft baseline, nocons) 
matrix `b2' = e(b)
matrix `v2' = e(V)
assert mreldif(`b', `b2') < 1E-4
assert mreldif(`v', `v2') < 1E-4

betafit governing , mu(minorityleft noleft lnhous lnpop) phi(lnpop lnhous minorityleft noleft baseline, nocons eform) 
matrix `b2' = e(b)
matrix `v2' = e(V)
assert mreldif(`b', `b2') < 1E-4
assert mreldif(`v', `v2') < 1E-4

betafit governing , alpha(minorityleft noleft lnhous lnpop) beta(lnpop lnhous minorityleft noleft)
assert `"`e(predict)'"'    == `"betafit_p"'
assert `"`e(depvar)'"'     == `"governing"'
assert `"`e(cmd)'"'        == `"betafit"'
assert `"`e(chi2type)'"'   == `"Wald"'
assert `"`e(title)'"'      == `"ML fit of beta (alpha, beta)"'
assert `"`e(user)'"'       == `"betafit_lf"'
assert `"`e(crittype)'"'   == `"log likelihood"'
assert `"`e(technique)'"'  == `"nr"'

assert         e(rc)             == 0
assert reldif( e(ll)              , 780.8731946109801 ) <  1E-6
assert         e(rank)           == 10
assert         e(k)              == 10
assert         e(k_eq)           == 2
assert         e(k_dv)           == 0
assert         e(ic)             == 5
assert         e(N)              == 394
assert         e(df_m)           == 4
assert reldif( e(chi2)            , 108.8930899416676 ) <  1E-4
assert reldif( e(p)               , 1.25325789652e-22 ) <  1E-4
assert         e(length_b_beta)  == 5
assert         e(length_b_alpha) == 5

tempname T_b 
mat `T_b' = J(1,10,0)
mat `T_b'[1,1] =  4.854534321684021
mat `T_b'[1,2] =  4.847935073697156
mat `T_b'[1,3] = -2.852295920433206
mat `T_b'[1,4] = -.4441985859088661
mat `T_b'[1,5] =  3.589302672495987
mat `T_b'[1,6] =  1.826031880899087
mat `T_b'[1,7] = -55.57734609473356
mat `T_b'[1,8] =  57.21878138210051
mat `T_b'[1,9] =  40.19028506579876
mat `T_b'[1,10] =  49.98027122055871
tempname C_b
matrix `C_b' = e(b)
assert mreldif( `C_b' , `T_b' ) < 1E-6
_assert_streq `"`: rowfullnames `C_b''"' `"y1"'
_assert_streq `"`: colfullnames `C_b''"' `"alpha:minorityleft alpha:noleft alpha:lnhous alpha:lnpop alpha:_cons beta:lnpop beta:lnhous beta:minorityleft beta:noleft beta:_cons"'
mat drop `C_b' `T_b'

tempname T_V 
mat `T_V' = J(10,10,0)
mat `T_V'[1,1] =   .674868885280872
mat `T_V'[1,2] =  .0160019981356429
mat `T_V'[1,3] =  .1173496692934298
mat `T_V'[1,4] = -.0119745774799898
mat `T_V'[1,5] =  -.143449973893393
mat `T_V'[1,6] = -.1042110257702841
mat `T_V'[1,7] =  1.313707323558472
mat `T_V'[1,8] =  7.076807066896815
mat `T_V'[1,9] = -.0249261718795572
mat `T_V'[1,10] = -1.279719116529492
mat `T_V'[2,1] =  .0160019981356429
mat `T_V'[2,2] =  .4453361483333432
mat `T_V'[2,3] = -.0089667515472452
mat `T_V'[2,4] =   .002188049779883
mat `T_V'[2,5] = -.0002231820359437
mat `T_V'[2,6] =   .053478363012858
mat `T_V'[2,7] = -.7864573098735374
mat `T_V'[2,8] = -.2709785256243189
mat `T_V'[2,9] =  2.981803896072166
mat `T_V'[2,10] =   .732822012631392
mat `T_V'[3,1] =  .1173496692934298
mat `T_V'[3,2] = -.0089667515472452
mat `T_V'[3,3] =  .5648500355228471
mat `T_V'[3,4] =  .0416970882606851
mat `T_V'[3,5] = -.2903746768598015
mat `T_V'[3,6] =  .2395936527178425
mat `T_V'[3,7] =  3.435855273644424
mat `T_V'[3,8] =   1.58785923246765
mat `T_V'[3,9] =  .4395538552168786
mat `T_V'[3,10] = -2.628006076596424
mat `T_V'[4,1] = -.0119745774799898
mat `T_V'[4,2] =   .002188049779883
mat `T_V'[4,3] =  .0416970882606851
mat `T_V'[4,4] =   .052767880958091
mat `T_V'[4,5] =  .0095898875268742
mat `T_V'[4,6] =  .4183409290041691
mat `T_V'[4,7] =  .4146644058550082
mat `T_V'[4,8] = -.2532881636768539
mat `T_V'[4,9] = -.1175116495824932
mat `T_V'[4,10] =  .1636358788680754
mat `T_V'[5,1] =  -.143449973893393
mat `T_V'[5,2] = -.0002231820359437
mat `T_V'[5,3] = -.2903746768598015
mat `T_V'[5,4] =  .0095898875268742
mat `T_V'[5,5] =  .2634102629879962
mat `T_V'[5,6] =  .2571269223858443
mat `T_V'[5,7] = -2.739146148302109
mat `T_V'[5,8] = -1.392539018479413
mat `T_V'[5,9] = -.0053718614017265
mat `T_V'[5,10] =  2.696057190588402
mat `T_V'[6,1] = -.1042110257702841
mat `T_V'[6,2] =   .053478363012858
mat `T_V'[6,3] =  .2395936527178425
mat `T_V'[6,4] =  .4183409290041691
mat `T_V'[6,5] =  .2571269223858443
mat `T_V'[6,6] =  4.873479825689271
mat `T_V'[6,7] =  1.394872187211041
mat `T_V'[6,8] = -2.245484562294803
mat `T_V'[6,9] = -.4629147819653767
mat `T_V'[6,10] =  4.922993292830431
mat `T_V'[7,1] =  1.313707323558472
mat `T_V'[7,2] = -.7864573098735374
mat `T_V'[7,3] =  3.435855273644424
mat `T_V'[7,4] =  .4146644058550082
mat `T_V'[7,5] = -2.739146148302109
mat `T_V'[7,6] =  1.394872187211041
mat `T_V'[7,7] =  44.16760097103404
mat `T_V'[7,8] =  15.84089718494449
mat `T_V'[7,9] = -4.746539583025932
mat `T_V'[7,10] = -36.40065765914927
mat `T_V'[8,1] =  7.076807066896815
mat `T_V'[8,2] = -.2709785256243189
mat `T_V'[8,3] =   1.58785923246765
mat `T_V'[8,4] = -.2532881636768539
mat `T_V'[8,5] = -1.392539018479413
mat `T_V'[8,6] = -2.245484562294803
mat `T_V'[8,7] =  15.84089718494449
mat `T_V'[8,8] =   85.2054924508397
mat `T_V'[8,9] =   .287630756807452
mat `T_V'[8,10] = -16.53969860821945
mat `T_V'[9,1] = -.0249261718795572
mat `T_V'[9,2] =  2.981803896072166
mat `T_V'[9,3] =  .4395538552168786
mat `T_V'[9,4] = -.1175116495824932
mat `T_V'[9,5] = -.0053718614017265
mat `T_V'[9,6] = -.4629147819653767
mat `T_V'[9,7] = -4.746539583025932
mat `T_V'[9,8] =   .287630756807452
mat `T_V'[9,9] =   26.1772999913024
mat `T_V'[9,10] =  3.503548016970975
mat `T_V'[10,1] = -1.279719116529492
mat `T_V'[10,2] =   .732822012631392
mat `T_V'[10,3] = -2.628006076596424
mat `T_V'[10,4] =  .1636358788680754
mat `T_V'[10,5] =  2.696057190588402
mat `T_V'[10,6] =  4.922993292830431
mat `T_V'[10,7] = -36.40065765914927
mat `T_V'[10,8] = -16.53969860821945
mat `T_V'[10,9] =  3.503548016970975
mat `T_V'[10,10] =  37.77540794706223
tempname C_V
matrix `C_V' = e(V)
assert mreldif( `C_V' , `T_V' ) < 1E-3
_assert_streq `"`: rowfullnames `C_V''"' `"alpha:minorityleft alpha:noleft alpha:lnhous alpha:lnpop alpha:_cons beta:lnpop beta:lnhous beta:minorityleft beta:noleft beta:_cons"'
_assert_streq `"`: colfullnames `C_V''"' `"alpha:minorityleft alpha:noleft alpha:lnhous alpha:lnpop alpha:_cons beta:lnpop beta:lnhous beta:minorityleft beta:noleft beta:_cons"'
mat drop `C_V' `T_V'

tempname T_b_alpha 
mat `T_b_alpha' = J(1,5,0)
mat `T_b_alpha'[1,1] =  4.854534321684021
mat `T_b_alpha'[1,2] =  4.847935073697156
mat `T_b_alpha'[1,3] = -2.852295920433206
mat `T_b_alpha'[1,4] = -.4441985859088661
mat `T_b_alpha'[1,5] =  3.589302672495987
tempname C_b_alpha
matrix `C_b_alpha' = e(b_alpha)
assert mreldif( `C_b_alpha' , `T_b_alpha' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_alpha''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_alpha''"' `"alpha:minorityleft alpha:noleft alpha:lnhous alpha:lnpop alpha:_cons"'
mat drop `C_b_alpha' `T_b_alpha'

tempname T_b_beta 
mat `T_b_beta' = J(1,5,0)
mat `T_b_beta'[1,1] =  1.826031880899087
mat `T_b_beta'[1,2] = -55.57734609473356
mat `T_b_beta'[1,3] =  57.21878138210051
mat `T_b_beta'[1,4] =  40.19028506579876
mat `T_b_beta'[1,5] =  49.98027122055871
tempname C_b_beta
matrix `C_b_beta' = e(b_beta)
assert mreldif( `C_b_beta' , `T_b_beta' ) < 1E-4
_assert_streq `"`: rowfullnames `C_b_beta''"' `"y1"'
_assert_streq `"`: colfullnames `C_b_beta''"' `"beta:lnpop beta:lnhous beta:minorityleft beta:noleft beta:_cons"'
mat drop `C_b_beta' `T_b_beta'

if c(stata_version) >= 11 {
	gen byte govern = 1 + minorityleft + 2*noleft
	betafit governing , mu(i.govern lnpop lnhous) phi(i.govern lnpop lnhous)
	matrix b = e(b)
	matrix b = b[1, 2..6], b[1,8..12]
	betafit governing , mu(minorityleft noleft lnpop lnhous) phi(minorityleft noleft lnpop lnhous)
	matrix b2 = e(b)
	assert mreldif(b, b2) < 1E-6

	betafit governing , alpha(i.govern lnpop lnhous) beta(i.govern lnpop lnhous)
	matrix b = e(b)
	matrix b = b[1, 2..6], b[1,8..12]
	betafit governing , alpha(minorityleft noleft lnpop lnhous) beta(minorityleft noleft lnpop lnhous)
	matrix b2 = e(b)
	assert mreldif(b, b2) < 1E-6
}
exit

